Attribute VB_Name = "Mod_SWOMSMacro"

Public Sub SWOMSMacro()
    Dim vFile, vFile2, workingDir, vslTblSubdir As String
    Dim currentMail As MailItem
    Dim currentItem, currentSelection As Object
    Dim i As Integer
    Dim answer As VbMsgBoxResult
    
	workingDir = "\\Hqs-nas-t-001\cg-5\CG-54\CG-543\CG-5432\" _
		& "ECP - Environmental Compliance Program Master File\EmailSystem\"
	vslTblSubdir = "VesselTables\"

	Set currentSelection = Application.ActiveExplorer.Selection
	If (currentSelection.Count > 100) Then
		answer = MsgBox("Running this macro on a large number of emails (" _
			& currentSelection.Count & ") may take a long time and could" _
			& "cause Outlook to become unstable. " & vbCrLf & vbCrLf _
			& "Are you sure you want to continue?", vbYesNo, "Warning")
		If answer = vbNo Then Exit Sub
	End If
    
	' Establish batch file
	' Random name for temporary batch file
	vFile2 = workingDir & "TMP" & (Rnd * 1000) & ".bat" 
	Open vFile2 For Output As #2
	' Go to the directory for the SWOMS parser
	If (Left(workingDir, 2) = "\\") Then
		Print #2, "pushd " & workingDir
	Else
		Print #2, Left(workingDir, 2)
		Print #2, "cd " & workingDir
	End If
    
    
	i = 0
	For Each currentItem In currentSelection
		If currentItem.Class = olMail Then
			' Server restricts max emails processed in this way to 249 per call
			i = i + 1
			If i >= 225 Then
				MsgBox ("This macro may only be run on 225 messages at once." & _
					vbCrLf & "Not all selected emails were processed.")
				GoTo closeandfinish
			End If
            
            
			Set currentMail = currentItem
			If ((InStr(currentMail.Subject, "Daily Report") <> 0) And _
					currentMail.FlagStatus <> olFlagComplete) Then
				currentMail.BodyFormat = olFormatPlain
				currentMail.UnRead = False
				currentMail.Save
							
			vFile = "VesselTables\" & "TMP" & (Rnd * 1000) & ".txt" ' Random name for temporary text file
			' Put body of the email into a temporary text file
			Open (workingDir & vFile) For Output As #1
			Print #1, currentMail.Body
			Close #1
						
			' Add to batch file to process data and clean up intermediate files
			' Run the parser on the email, wait until it finishes
			Print #2, "start /wait swomsparser " & ".\" & vFile   
			Print #2, "del .\" & vFile   ' Instruction to delete input file
						
			currentMail.FlagStatus = olFlagComplete
			currentMail.Close (olSave)
			End If
		End If
	Next

closeandfinish:
    Print #2, "del %0"
    Close #2
                
    ' Run the batch script outlined above
    Shell (vFile2)
End Sub



' Run RemoveLocks function
Public Sub ManualUnlock()
    Dim inString As String
    Dim answer As VbMsgBoxResult
    
    answer = MsgBox("Running this macro may cause errors if any of the files are open." _
                    & vbCrLf & "Would you like to continue?", vbYesNo, "Manual Unlock")
    If answer = vbYes Then
        inString = InputBox("Please enter directory, including trailing slash (\)", _
                    "Manual Unlock", "\\Hqs-nas-t-001\cg-5\CG-54\CG-543\CG-5432\" & _
                    "ECP - Environmental Compliance Program Master File\EmailSystem\")
        If Dir(inString) <> "" Then RemoveLocks (inString)
        Else: MsgBox ("Invalid directory!")
    End If
End Sub

' Only necessary to clean up if a run fails. 
Public Function RemoveLocks(directory As String)
    ' Remove .lock files from a single folder
    On Error Resume Next
    Kill (directory & "*.LOCK")
    On Error GoTo 0
End Function
